;****************************************
;*              SNG v0.4                *
;*      Shell avec Niveaux de Gris      *
;*                                      *
;*         par Marc Plouhinec           *
;* site: http://thebestof.vze.com       *
;* Email: mailto://m_plouhinec@yahoo.fr *
;*                                      *
;****************************************



;Zones de la mmoire:
;--------------------

KEY_0        = $8000
KEY_1        = $8001
KEY_2        = $8002
KEY_STAT     = $8004
LAST_KEY     = $8006
CONTRAST     = $8008
CURSOR_POS   = $800C
CURSOR_ROW   = $800C
CURSOR_COL   = $800D
BUSY_COUNTER = $8026
BUSY_BITMAP  = $8027
OP1          = $8028
OP2          = $8033
OP3          = $803E
OP4          = $8049
OP5          = $8054
OP6          = $805F
TEXT_MEM     = $808F
GRAF_CURS    = $8215
CURSOR_X     = $8215
CURSOR_Y     = $8216
APD_BUF      = $8228
_IY_TABLE    = $8528
GRAPH_MEM    = $88B8
TEXT_MEM2    = $8BDF
WIN_START    = $8C8F
WIN_END      = $8C90
VAT_START    = $FE6E
VAT_END      = $8D18 ;Attention la fin de la VAT est indique  l'adresse $8D18
PLANE_0      = GRAPH_MEM
PLANE_1      = $95CE

;Appels de la ROM (19.006):
;--------------------------

LD_HL_MHL   = $0033 ;HLA       HL=(HL), A=L
CP_HL_DE    = $0095 ;F         CP  HL, DE
TX_CHARPUT  = $3B35
M_CHARPUT   = $3907
D_ZT_STR    = $3A2D
D_ZM_STR    = $390D
CLEAR_TEXT  = $38E9
CLEAR_LCD   = $39F1
GET_KEY     = $01F3
STORE_KEY   = $01E6
FIND_VAT    = $2269
UNPACK_HL   = $00A1
CREATE_PRGM = $24DC
DEL_MEM     = $26D2
INSERT_MEM  = $239D
MEM_FREE    = $23F3
DEL_TMP     = $374B
CREATE_TMP  = $3A03
INT_STATE   = $8229

CLEARLCD     = $389A+$133
D_HL_DECI    = $387C+$133
D_LM_STR     = $37DA+$139
BUSY_ON      = $394A+$149
BUSY_OFF     = $3932+$13D
TR_CHARPUT   = $3738+$145
KEY_HAND     = $3924+$163

;Appels de SNG :
;---------------
MUL_HL_BC           =$8D4D
FILL                =$8D50
GET_RAND            =$8D53 ;RAND = srl a \ GET_RAND
PAUSE               =$8D56
HL_DECI             =$8D59
DISP_GRAPH          =$8D5C ; = GRB_COPY
GRB_FILL            =$8D5F
DIRECT_KEY          =$8D62
DISP_DELAY          =$8D65
LINK_SEND           =$8D68 ;pas encore implment
LINK_GET            =$8D6B ;pas encore implment
EXIT_TIOS           =$8D6E ;pas encore implment
FIND_INIT           =$8D71
FIND_NEXT           =$8D74
KHAND               =$8D77 ;pas encore implment
;fonctions propres  SNG:
CLR_BUF             =$8D7A
GRAYSCALE_ON        =$8D7D
GRAYSCALE_OFF       =$8D80
GRAYSPRITE          =$8D83 ;pas encore implment
GRAYPIC             =$8D86 ;pas encore implment
DECOMPRESS_PIC      =$8D89 ;pas encore implment
BEEP                =$8D8C ;pas encore implment
SPRITE              =$8D8F ;pas encore implment
CLEAR_TEXT_MEM      =$8D92
FILL_TEXT_MEM_SPACE =$8D95
SUB_HL_BC           =$8D98
HL_HEX              =$8D9B

;Ports:
;------

P_LINK       = $00
P_KEYBOARD   = $01
P_ROM        = $02
P_STATUS     = $03
P_INT        = $04
P_LCD_CON    = $10
P_LCD_DATA   = $11


;Touches:
;--------

G_NONE   = $00
G_DOWN   = $01
G_LEFT   = $02
G_RIGHT  = $03
G_UP     = $04
G_ENTER  = $09
G_PLUS   = $0A
G_MINUS  = $0B
G_TIMES  = $0C
G_DIV    = $0D
G_CARROT = $0E
G_CLEAR  = $0F
G_NEG    = $11
G_3      = $12
G_6      = $13
G_9      = $14
G_PARENR = $15
G_TAN    = $16
G_VARS   = $17
G_PERIOD = $19
G_2      = $1A
G_5      = $1B
G_8      = $1C
G_PARENL = $1D
G_COS    = $1E
G_PRGM   = $1F
G_STAT   = $20
G_0      = $21
G_1      = $22
G_4      = $23
G_7      = $24
G_COMMA  = $25
G_SIN    = $26
G_MATRIX = $27
G_XTO    = $28
G_ON     = $29
G_STO    = $2A
G_LN     = $2B
G_LOG    = $2C
G_SQR    = $2D
G_INVE   = $2E
G_MATH   = $2F
G_ALPHA  = $30
G_GRAPH  = $31
G_TRACE  = $32
G_ZOOM   = $33
G_WINDOW = $34
G_YEDIT  = $35
G_2ND    = $36
G_MODE   = $37
G_DEL    = $38

K_RIGHT   =   1 ; RIGHT     RIGHT
K_LEFT    =   2 ; LEFT      LEFT
K_UP      =   3 ; UP        UP
K_DOWN    =   4 ; DOWN      DOWN
K_ENTER   =   5 ; ENTER     ENTER
K_CLEAR   =   6 ; CLEAR     CLEAR
K_DEL     =   7 ; DEL       DEL
K_INS     =   8 ; DEL       INS
K_RCL     =   9 ; STO>      RCL
K_ENTRY   =  10 ; ENTER     ENTRY
K_BOL     =  11 ; LEFT      BOL
K_EOL     =  12 ; RIGHT     EOL
K_PRGM    =  45 ; PRGM      PRGM
K_ZOOM    =  46 ; ZOOM      ZOOM
K_DRAW    =  47 ; PRGM      DRAW
K_PLOT    =  48 ; Y=        STAT PLOT
K_MATH    =  49 ; MATH      MATH
K_TEST    =  50 ; MATH      TEST
K_VARS    =  52 ; VARS      VARS
K_MEM     =  53 ; +         MEM
K_MATRIX  =  54 ; MATRIX    MATRIX
K_STAT    =  55 ; STAT      STAT
K_Y-VARS  =  56 ; VARS      Y-VARS
K_ANGLE   =  57 ; MATRIX    ANGLE
K_LIST    =  58 ; STAT      LIST
K_CALC    =  59 ; TRACE     CALC
K_QUIT    =  64 ; MODE      QUIT
K_LINK    =  65 ; X,T,theta LINK
K_GRAPH   =  69 ; GRAPH     GRAPH
K_MODE    =  70 ; MODE      MODE
K_WINDOW  =  73 ; WINDOW    WINDOW
K_YEDIT   =  74 ; Y=        Y=
K_TABLE   =  75 ; GRAPH     TABLE
K_TBLSET  =  76 ; WINDOW    TblSet
K_TRACE   =  93 ; TRACE     TRACE
K_PLUS    = 129 ; +         +
K_MINUS   = 130 ; -         -
K_TIMES   = 131 ; *         *
K_DIV     = 132 ; /         /
K_POWER   = 133 ; ^         ^
K_LPAREN  = 134 ; (         (
K_RPAREN  = 135 ; )         )
K_LBRACK  = 136 ; *         [
K_RBRACK  = 137 ; -         ]
K_STO     = 139 ; STO>      STO>
K_COMMA   = 140 ; ,         ,
K_NEG     = 141 ; (-)       (-)
K_PERIOD  = 142 ; .         .
K_0       = 143 ; 0         0
K_1       = 144 ; 1         1
K_2       = 145 ; 2         2
K_3       = 146 ; 3         3
K_4       = 147 ; 4         4
K_5       = 148 ; 5         5
K_6       = 149 ; 6         6
K_7       = 150 ; 7         7
K_8       = 151 ; 8         8
K_9       = 152 ; 9         9
K_EE      = 153 ; ,         EE
K_SEMI    = 154 ; 0         ;
K_A       = 155 ; MATH      A
K_B       = 156 ; MATRIX    B
K_C       = 157 ; PRGM      C
K_D       = 158 ; X^-1      D
K_E       = 159 ; SIN       E
K_F       = 160 ; COS       F
K_G       = 161 ; TAN       G
K_H       = 162 ; ^         H
K_I       = 163 ; X^2       I
K_J       = 164 ; ,         J
K_K       = 165 ; (         K
K_L       = 166 ; )         L
K_M       = 167 ; /         M
K_N       = 168 ; LOG       N
K_O       = 169 ; 7         O
K_P       = 170 ; 8         P
K_Q       = 171 ; 9         Q
K_R       = 172 ; *         R
K_S       = 173 ; LN        S
K_T       = 174 ; 4         T
K_U       = 175 ; 5         U
K_V       = 176 ; 6         V
K_W       = 177 ; -         W
K_X       = 178 ; STO>      X
K_Y       = 179 ; 1         Y
K_Z       = 180 ; 2         Z
K_XTO     = 181 ; X,T,theta X,T,theta
K_PI      = 182 ; ^         Pi
K_INVERSE = 183 ; X^-1      X^-1
K_SIN     = 184 ; SIN       SIN
K_ASIN    = 185 ; SIN       SIN^-1
K_COS     = 186 ; COS       COS
K_ACOS    = 187 ; COS       COS^-1
K_TAN     = 188 ; TAN       TAN
K_ATAN    = 189 ; TAN       TAN^-1
K_SQR     = 190 ; X^2       X^2
K_SQRT    = 191 ; X^2       SQRT
K_LN      = 192 ; LN        LN
K_EX      = 193 ; LN        e^X
K_LOG     = 194 ; LOG       LOG
K_TENP    = 195 ; LOG       10^X
K_ANS     = 198 ; (-)       ANS
K_COLON   = 199 ; .         :
K_QUEST   = 203 ; (-)       ?
K_QUOTE   = 204 ; +         "
K_THETA   = 205 ; 3         THETA
K_LBRACE  = 237 ; (         {
K_RBRACE  = 238 ; )         }
K_ABS     = 244 ; X^-1      ABS
K_L1      = 245 ; 1         L1
K_L2      = 246 ; 2         L2
K_L3      = 247 ; 3         L3
K_L4      = 248 ; 4         L4
K_L5      = 249 ; 5         L5
K_L6      = 250 ; 6         L6
K_n       = 251 ; 9         n
K_Vn1     = 252 ; 8         Vn-1
K_Un1     = 253 ; 7         Un-1

;Macros
;------
#Define PRINTN(a,b) LD HL,a\ LD (CURSOR_POS),HL\ LD HL,b\ CALL D_ZT_STR
#Define PRINTM(a,b) LD HL,a\ LD (GRAF_CURS),HL\ LD HL,b\ CALL D_ZM_STR
#DEFINE CP_HL_BC  PUSH HL\ OR A\ SBC HL,BC\ POP HL

START_ADDR = $A500
.ORG START_ADDR

.END